/*
 *  WeaponBoomerang.cpp
 *  Knightmare
 *
 *  Created by Santi Ontañón on 11/13/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */


#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif

#include "debug.h"

#include "Knightmare.h"

#include "WeaponBoomerang.h"
#include "KPlayer.h"
#include "KObjectCreator.h"

WeaponBoomerang::WeaponBoomerang(int x,int y,int sfx_volume,GLTManager *GLTM, KPlayer *owner) : Weapon(x,y,sfx_volume,owner)
{
	int i;
	
	m_class = weaponarrow_symbol;
	
    m_n_states = 1;
    m_state_animations = new Animation *[1];
	
    for(i=0;i<1;i++) m_state_animations[i]=0;
	
    m_state = 0;
	
	Animation *a = new Animation(true);
	a->addFrame(GLTM->get("bumerang-001"),4);
	a->addFrame(GLTM->get("bumerang-002"),4);
	a->addFrame(GLTM->get("bumerang-003"),4);
	a->addFrame(GLTM->get("bumerang-004"),4);
	a->addFrame(GLTM->get("bumerang-005"),4);
	a->addFrame(GLTM->get("bumerang-006"),4);
	a->addFrame(GLTM->get("bumerang-007"),4);
	a->addFrame(GLTM->get("bumerang-008"),4);
	m_state_animations[0]=a;
	
}


WeaponBoomerang::~WeaponBoomerang() {
}


bool WeaponBoomerang::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	Weapon::cycle(vcl,game,GLTM,SFXM);
	
	m_state_cycle++;

	// just a small parabolla for the move of teh boomerang:
	float x = m_state_cycle/20.0f;
	float speed_y = (-0.03125)*x*x + 3.0f*x -8.0f;
	m_y += speed_y;
	
	m_x = m_owner->get_x();
	
//	m_y-=8.0f;
	
	if (m_y<game->get_map_position()-50 || m_y>m_owner->get_y()) {
		m_owner->weaponDisappeared(this);
		return false;
	}
	
	if (game->get_map()->collisionWithTypes(this,0,0,game->getObstacleClasses())) {
		// Collision with a wall:
		// TODO: weapon destroyed effect
		m_owner->weaponDisappeared(this);
		return false;
	}
	
	return true;
}


bool WeaponBoomerang::is_a(Symbol *c)
{
    if (c->cmp(weaponboomerang_symbol))
        return true;
	
    return Weapon::is_a(c);
} /* WeaponBoomerang::is_a */


bool WeaponBoomerang::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);
	
    retval = is_a(s);
	
    delete s;
	
    return retval;
} /* WeaponBoomerang::is_a */

